// Header File
// Created 29/06/2005; 16:20:26
#ifndef __HAWK_clavier_H__
#define __HAWK_clavier_H__

//==========================================================================//
//	Dfinitions des touches
//==========================================================================//

#define FIRE_KEY	(TI89 ? 0: 6), 4	// SECOND pour TI89 et F1 pour TI92+/V200 (utilise _keytest)
#define HAUT			(TI89 ? (touche[0] & 1): (touche[0] & 32))
#define BAS				(TI89 ? (touche[0] & 4): (touche[0] & 128))
#define DROITE		(TI89 ? (touche[0] & 8): (touche[0] & 64))
#define GAUCHE		(TI89 ? (touche[0] & 2): (touche[0] & 16))
#define ENTER			(TI89 ? ((touche[1] & 1) || (touche[0] & 16)): ((touche[6] & 64) || (touche[9] & 2) || (touche[0] & 8)))	// SECOND ou ENTER pour TI89 et ENTER2 ou ENTER1 ou HAND pour TI92+
#define ESCAPE		(TI89 ? (touche[6] & 1): (touche[8] & 64))
#define PAUSE			(TI89 ? (touche[1] & 1): ((touche[6] & 64) || (touche[9] & 2)))	// ENTER pour TI89 et ENTER2 ou ENTER1 pour TI92+

//==========================================================================//
//	Attend l'appui d'une touche et permet de supprimer la rptition de touche
//	Option 1: ne fait rien tant qu'aucune touche n'est presse;
//	Option 2: teste une fois toutes les touches puis sort de la boucle. 
//==========================================================================//

#define NE_FAIT_RIEN		1
#define	TESTE_ET_SORT		2

void PressionTouche(short option)
{
	register short tampon, rangee, APPS, MOINS, PLUS;
	long apd;
  rangee = 0;
  apd = 0;
  
	do
	{
		rangee ++;
		rangee %= NB_COL;
		tampon = vieille_t[rangee];
	  touche[rangee] = _rowread(~(1<<rangee));
	  vieille_t[rangee] = touche[rangee];
	  touche[rangee] &= ~tampon; 	
	  
	  if(TI89)
	  {
	  	APPS = (touche[5] & 1);
	  	MOINS = (touche[1] & 4);
	  	PLUS = (touche[1] & 2);
	  }
	  else
	  {
	  	APPS = (touche[7] & 64);
	  	MOINS = (touche[9] & 1);
	  	PLUS = (touche[8] & 16);
	  }
	  
		if((APPS || (apd ++) == 400000))	// Valeur double pour squale92
		{		
			off();
			apd = 0;
			touche[rangee] = 0;
		}
		
		else if(MOINS)
		{
			OSContrastDn();
			apd = 0;
			touche[rangee] = 0;
		}
		
		else if(PLUS)
		{
			OSContrastUp();
			apd = 0;
			touche[rangee] = 0;
		}
		
	}while(option == NE_FAIT_RIEN ? touche[rangee] == 0: rangee != 0);
	
}

//==========================================================================//

#endif