// C Source File
// Created 01/07/2004; 16:08:22

#include <tigcclib.h>

#include "extgraph.h"
#include "prototypes.h"
#include "memoire.h"
#include "initialise.h"
#include "clavier.h"
#include "images.h"
#include "fontes.h"
#include "graphique.h"
#include "listes.h"
#include "animations.h"
#include "divers.h"
#include "menus.h"
#include "bombes.h"
#include "hiscores.h"


//==========================================================================//
//	Fonction du jeu
//==========================================================================//

void jeu(void)
{
	short x_vaiss, y_vaiss, abort, flag_tir, i;	// 'flag_tir' sert  espacer les tirs
	EffaceTousEcrans();
	InitListes();
	InitFond();
	OSContrastUp();
	
	
	TEMPO_FOND = 2;
	TEMPO_OEIL = (mode ? 62: 76);
	x_vaiss = -1;
	y_vaiss = 60;
	abort = 0;
	compteur = 0;
	last_bombe = NOTHING;
	last_proj = NOTHING;
	last_anim = NOTHING;
	last_trompe = NOTHING;
	flag_tir = 0;
	flag_crash = -59;
	flag_oeil = NOTHING;
	flag_mur = NOTHING;
	flag_bonus = NOTHING;
	indice_global = 0;
	y_vscreen = 14;
	score = 0;
	vie = lives;
	last_animspe = 0;
	rapid_fire_unit = 0;
	morts = 1;
	indice_vaisseau = 0;
	taille_canon = 1;
	tempo_tir = 10;
	vaisseau_speed = 2;
	shield = NOTHING;
	
	
	do
	{
		flag_touche_fire = (_keytest(FIRE_KEY) ? flag_touche_fire: 0);	// Auto pirat  'Tetrics'
		PressionTouche(TESTE_ET_SORT);
		
		if(_keytest(FIRE_KEY) && last_bombe < (NB_MAX_BOMBES-taille_canon))	// On a lch une bombe ! (touche 2ND pour TI-89 et F1 pour TI-92+/V200)
		{
			if(!flag_tir)
			{
				if(rapid_fire_unit)
				{
					InitBombes(x_vaiss, y_vaiss);
					flag_tir ++;
				}
				else
				{
					if(!flag_touche_fire)
					{
						InitBombes(x_vaiss, y_vaiss);
						flag_tir ++;
					}
				}	
			}
		}
		
		if(flag_tir != 0)
		{
			flag_tir ++;
			flag_tir %= tempo_tir;
		}
		
		for(i = vaisseau_speed; (i --);)
		{
			if(flag_crash <= 0)
			{	
				BEGIN_KEYTEST	// Gestion du dplacement en diagonale demand par Jfg sur Ti-Gen (merci :)
				if(_keytest_optimized(RR_UP) && y_vaiss >= 0)
				{
					y_vaiss --;
					if(y_vscreen > 0 && y_vaiss < 100)	// Scrolle l'cran vers le haut (uniquement pour TI89)
					{
						y_vscreen --;
					}
				}
				else if(_keytest_optimized(RR_DOWN) && y_vaiss < 111)
				{
					y_vaiss ++;
					if(y_vscreen < 28 && y_vaiss > 28)	// Scrolle l'cran vers le bas (uniquement pour TI89)
					{
						y_vscreen ++;
					}
				}	// Pas de 'else if' pour la diagonalit
				if(_keytest_optimized(RR_RIGHT) && x_vaiss < 135)
				{
					x_vaiss ++;
				}
				else if(_keytest_optimized(RR_LEFT) && x_vaiss >= 0)
				{
					x_vaiss --;
				}
				END_KEYTEST
			}
		}
		
		flag_touche_fire = _keytest(FIRE_KEY);
		
		DeplaceFond();
		FastCopyScreen_R(screen_fond_0, vscreen_0);
		FastCopyScreen_R(screen_fond_1, vscreen_1);
		DeplaceBords();
		CopieBordsToScreen();
		AfficheAnims();
		AfficheAnimsSpeciales();
		AfficheProjectiles();
		GenereBonus();
		AfficheBonus();
		AfficheBombes();
		AfficheScore();
		AfficheVaisseau(x_vaiss, y_vaiss);
		
		if(flag_crash == 4*TEMPO_EXPLOSION_BOMBE)
		{
			vie --;
			if(vie == 0)
			{
				AfficheMsg("CRASH!");
				EnterEsc();
				break;
			}
			else
			{
				flag_crash = -59;
			}
		}
		
		FastCopyScreen_R(vscreen_0+(TI89 ? 30*y_vscreen: 0), __L_plane);
		FastCopyScreen_R(vscreen_1+(TI89 ? 30*y_vscreen: 0), __D_plane);
		
		GestionPause();
		
		compteur ++;
	
		if(compteur == anims_timing[mode][indice_global])
		{
			indice_global ++;
			InitAnims();
		}
		
		if(ESCAPE)
		{
			AfficheAbort(&abort);
		}
		
		 
	}while(!abort && compteur_bords < 479);
	
	OSContrastDn();
	AjusteContrasteHaut();
	
	AfficheGameOver();
	PressionTouche(TESTE_ET_SORT);	//	Purge le clavier
	
	if(compteur_bords == 479)
	{
		AfficheFelicitations();
	}
	
	if(score > hscore[4].score)
	{
		HiScore();
	}
}

//==========================================================================//
//	Fonction principale appele au lancement du jeu
//==========================================================================//

void _main(void)
{
	Installation();
	AlloueMemoire();
	FastCopyScreen_R(LCD_MEM, ecran_LCD);
	EM_moveSymFromExtMem(SYMSTR("hawksav"), HS_NULL);		//	Dsarchive la variable 'hawksav'
	RedirigeInterruptions();
	OuvreFichierSauvegarde();
	AfficheTitre();
	y_menu = 21;
	TransitionBas();
	InitMenu();
	AfficheMenu();
	TransitionHaut();
	AjusteContrasteBas();
	
	do
	{
		compteur ++;
		compteur %= 4800; // multiple de 3 et de 16
		AfficheMenu();
		PressionTouche(TESTE_ET_SORT);
		
		if(BAS)
		{
			y_menu = (y_menu == 69 ? 21: y_menu+12);
		}
		else if(HAUT)
		{
			y_menu = (y_menu == 21 ? 69: y_menu-12);
		}
		else if(ENTER)
		{
			if(y_menu == 69)
			{
				break;
			}
			
			switch(y_menu)
			{
				case 21:
				jeu();
				TransitionBas();
				InitMenu();
				AfficheMenu();
				TransitionHaut();
				AjusteContrasteBas();
				break;
				case 33:
				AjusteContrasteHaut();
				MenuOptions();
				AjusteContrasteBas();
				break;
				case 45:
				TransitionBas();
				AjusteContrasteHaut();
				MenuHiscores();
				TransitionHaut();
				EnterEsc();
				PressionTouche(TESTE_ET_SORT);	//	Purge le clavier
				TransitionBas();
				InitMenu();
				AfficheMenu();
				TransitionHaut();
				AjusteContrasteBas();
				break;
				case 57:
				AjusteContrasteHaut();
				MenuAbout();
				AjusteContrasteBas();
				break;
			}
		}
	}while(!ESCAPE);
	
	AjusteContrasteHaut();
	FermeFichierSauvegarde();
	PortRestore();
	AfficheLCD(ecran_LCD);
	RestaureInterruptions();
	LibereMemoire();
	ST_showHelp("Hawk by Nul "VERSION);
	EM_moveSymToExtMem(SYMSTR("hawksav"), HS_NULL); //	Archive la variable 'hawksav'
	GKeyFlush();	//	Permet de ne pas relancer le programme si on a laiss la touche 'ENTER' appuye
}

//==========================================================================//